#include <Xm/Xm.h>
#include <Xm/FileSB.h>
#include <Xm/MessageB.h>
#include <Xm/List.h>
#include <Xm/TextF.h>
#include <Xm/RowColumn.h>
#include <X11/cursorfont.h>
#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <errno.h>
#include "global.h"

void f_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
         int    item;
  static Widget fsb_ld, ft_ld, fsb_sd, ft_sd;
  XmStringTable str_list;
  unsigned int  n, nitems;

  void ld_cb(Widget, XtPointer, XtPointer);
  void sd_cb(Widget, XtPointer, XtPointer);
  void fsb_cancel(Widget, XtPointer, XtPointer);
  extern void clearscreen();

  item=(int) client_data;

  switch(item) {
  case 0:      // new;
    /* free channels */
    while (r.n>0) {
      r.DelChannel(0);
    }
    /* clear list of comments */
    XmListDeleteAllItems(c_list_w);
    /* set menuitems */
    XtSetSensitive(mymenu.file.n_data,False);
    XtSetSensitive(mymenu.file.s_data,False);
    XtSetSensitive(mymenu.file.l_data,True);
    XtSetSensitive(mymenu.file.p_data,False);
    XtSetSensitive(mymenu.edit.mean,False);
    XtSetSensitive(mymenu.edit.area,False);
    XtSetSensitive(mymenu.edit.min,False);
    XtSetSensitive(mymenu.edit.max,False);
    XtSetSensitive(mymenu.edit.dif,False);
    XtSetSensitive(mymenu.edit.deltax,False);
    XtSetSensitive(mymenu.edit.copy,False);
    XtSetSensitive(mymenu.edit.del,False);
    XtSetSensitive(mymenu.edit.reduce,False);
    XtSetSensitive(mymenu.calc.hr1,False);
    XtSetSensitive(mymenu.calc.hr2,False);
    XtSetSensitive(mymenu.calc.filter,False);
    XtSetSensitive(mymenu.calc.interpol,False);
    XtSetSensitive(mymenu.calc.movavg,False);
    XtSetSensitive(mymenu.calc.seqavg,False);
    XtSetSensitive(mymenu.calc.rectify,False);
    XtSetSensitive(mymenu.calc.invert,False);
    XtSetSensitive(mymenu.calc.differentiate,False);
    XtSetSensitive(mymenu.calc.linear,False);
    XtSetSensitive(mymenu.calc.twochtrans,False);
    XtSetSensitive(mymenu.calc.fft,False);
    XtSetSensitive(mymenu.calc.baro,False);
    XtSetSensitive(mymenu.calc.artifact,False);
    XtSetSensitive(mymenu.view.redraw,False);
    XtSetSensitive(mymenu.view.zoom,False);
    XtSetSensitive(mymenu.view.total,False);
    XtSetSensitive(mymenu.view.hide,False);
    XtSetSensitive(mymenu.view.all,False);
    XtSetSensitive(mymenu.view.comments,False);
    XtSetSensitive(mess.rowcol_w,False);
    XtSetSensitive(toolb_w,False);
clearscreen();
    break;
  case 1:      // load data;
    if (!fsb_ld) {
      fsb_ld=XmCreateFileSelectionDialog(drawing_a, "filesb", NULL, 0);
      XtVaSetValues(XtParent(fsb_ld),
		    XmNtitle, "Load Data",
		    NULL);
      str_list=(XmStringTable) XtMalloc(4*sizeof(XmString));
      str_list[0]=XmStringCreateLocalized("ASCII");
      str_list[1]=XmStringCreateLocalized("TSA");
      str_list[2]=XmStringCreateLocalized("MAD");
      str_list[3]=XmStringCreateLocalized("WAV");
     
      ft_ld=XmCreateScrolledList(fsb_ld, "filetype", NULL, 0);
      XtVaSetValues(ft_ld,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    XmNvisibleItemCount, 4,
		    XmNitemCount, 4,
		    XmNitems, str_list,
		    NULL);
      XmListSelectPos(ft_ld, 3, True);
      XtAddCallback(fsb_ld,XmNokCallback, ld_cb, ft_ld);
      XtAddCallback(fsb_ld,XmNcancelCallback, fsb_cancel, NULL);
      XtFree((char *)str_list);
    }
    XtManageChild(ft_ld);
    XtManageChild(fsb_ld);
    break;
  case 2:      // save data;
    if (!fsb_sd) {
      fsb_sd=XmCreateFileSelectionDialog(drawing_a, "filesb", NULL, 0);
      XtVaSetValues(XtParent(fsb_sd),
		    XmNtitle, "Save Data",
		    NULL);
      str_list=(XmStringTable) XtMalloc(3*sizeof(XmString));
      str_list[0]=XmStringCreateLocalized("ASCII");
      str_list[1]=XmStringCreateLocalized("TSA");
      str_list[2]=XmStringCreateLocalized("MAD");
      ft_sd=XmCreateScrolledList(fsb_sd, "filetype", NULL, 0);
      XtVaSetValues(ft_sd,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    XmNvisibleItemCount, 2,
		    XmNitemCount, 3,
		    XmNitems, str_list,
		    NULL);
      XmListSelectPos(ft_sd, 1, True);
      XtAddCallback(fsb_sd,XmNokCallback, sd_cb, NULL);
      XtAddCallback(fsb_sd,XmNcancelCallback, fsb_cancel, NULL);
      XtVaSetValues(fsb_sd, XmNuserData, ft_sd, NULL);
      XtFree((char *)str_list);
    }
    XtManageChild(ft_sd);
    XtManageChild(fsb_sd);
    break;
  case 3:      // quit;
    exit(0);
    break;
  }

}

/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */
void fsb_cancel(Widget widget, XtPointer client_data, XtPointer call_data) {
  XtUnmanageChild(widget);
}

void ld_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  char          *filename, text[100], *pfname;
  Cursor        uhr, pfeil;
  int           i, rc, nch_old;
  int           *pos_list, pos_cnt;
  Arg           args[5];
  static Widget mbox, tfield;
  Widget        madbox, toplevel;
  unsigned int  n;
  XmString      *list_item;
  char          list_char[256];
  
  extern void da_cb(Widget widget, XtPointer client_data, XtPointer call_data);
  extern Widget GetTopLevelShell(Widget w);
  void ok_sr(Widget widget, XtPointer client_data, XtPointer call_data);

  /* get filename */
  XmFileSelectionBoxCallbackStruct *cbs=
    (XmFileSelectionBoxCallbackStruct *) call_data;
  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }

  /* get filetype 1: ASCII, 2: TSA, 3: MAD, 4:WAV */
  /* returned in pos_list[0]               */
  XmListGetSelectedPos((Widget)client_data,&pos_list,&pos_cnt);
  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);

  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  /* remember the former number of channels */
  nch_old=r.n;

  switch(pos_list[0]) {
  case 1: // ASCII file format;
    if (!mbox) {
      i=0;
      XtSetArg(args[i], XmNmessageString, XmStringCreateLtoR("need sampling rate (Hz) for ASCII file:",XmFONTLIST_DEFAULT_TAG)); i++;
      XtSetArg(args[i], XmNtitle, "sampling rate"); i++;
      XtSetArg(args[i], XmNautoUnmanage, False); i++;
      mbox=XmCreateMessageDialog(drawing_a, "sr", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(mbox, XmDIALOG_HELP_BUTTON));
      tfield=XtVaCreateWidget("tfield", xmTextFieldWidgetClass, mbox,
			      NULL);
      sprintf(text,"%d",1000);
      XtVaSetValues(tfield,
		    XmNvalue, text,
		    XmNuserData, widget,
		    NULL);
      XtAddCallback(mbox, XmNokCallback, ok_sr, tfield);
      XtAddCallback(mbox, XmNcancelCallback, fsb_cancel, NULL);
    }
    XtManageChild(tfield);
    XtManageChild(mbox);
    rc=-1;
    break;
  case 2: // TSA file format;
    rc=r.ReadTSA(filename);
    break;
  case 3: // MAD file format;
    rc=r.ReadMAD(filename);
    break;
  case 4: // WAV file format;
    rc=r.ReadWAV(filename);
  }
  if (rc>=0) {
    r.alloc_view(r.n);
    r.t_1=0; r.t_2=0; r.nvis+=(r.n-nch_old);
    for (i=nch_old; i<r.n; i++) {
      r.view[i].is_active=0;
      r.view[i].is_visible=1;
      if (!strcmp(r.ch[i].name,"fft")) r.view[i].is_frequency=1;
      else r.view[i].is_frequency=0;
      r.view[i].min=r.ch[i].min;
      r.view[i].max=r.ch[i].max;
      strcpy(r.view[i].from_file,filename);
      if (r.t_2<r.ch[i].n/r.ch[i].sr) r.t_2=r.ch[i].n/r.ch[i].sr;
    }
    /* set list of comments */
    XmListDeleteAllItems(c_list_w);
    list_item=new XmString[r.comments->n];
    for (n=0; n<r.comments->n; n++) {
      sprintf(list_char,"%03d %02d:%02d:%02d %s",
	      n+1, r.comments->time[n]/3600,
	      (r.comments->time[n]-(r.comments->time[n]/3600))/60,
	      r.comments->time[n]-60*(r.comments->time[n]/60),
	      r.comments->comment[n]);
      list_item[n]=XmStringCreateLocalized(list_char);
    }
    XmListAddItemsUnselected(c_list_w, list_item, r.comments->n, 0);
    for (n=0; n<r.comments->n; n++) XmStringFree(list_item[n]);
    delete[]list_item;
    /* set new title string */
    pfname=strrchr(filename,'/');
    if (pfname) pfname=pfname+1;
    else pfname=filename;
    strcpy(text,"xmana v"VERSION": "); strcat(text,pfname);
    XtVaSetValues(GetTopLevelShell(drawing_a), XmNtitle, text, NULL);
    da_cb(NULL, NULL, NULL);

    XtSetSensitive(mymenu.file.n_data,True);
    XtSetSensitive(mymenu.file.s_data,True);
    XtSetSensitive(mymenu.file.p_data,True);
    XtSetSensitive(mymenu.edit.mean,True);
    XtSetSensitive(mymenu.edit.area,True);
    XtSetSensitive(mymenu.edit.min,True);
    XtSetSensitive(mymenu.edit.max,True);
    XtSetSensitive(mymenu.edit.dif,True);
    XtSetSensitive(mymenu.edit.deltax,True);
    XtSetSensitive(mymenu.edit.copy,True);
    XtSetSensitive(mymenu.edit.del,True);
    XtSetSensitive(mymenu.edit.reduce,True);
    XtSetSensitive(mymenu.calc.hr1,True);
    XtSetSensitive(mymenu.calc.hr2,True);
    XtSetSensitive(mymenu.calc.filter,True);
    XtSetSensitive(mymenu.calc.interpol,True);
    XtSetSensitive(mymenu.calc.movavg,True);
    XtSetSensitive(mymenu.calc.seqavg,True);
    XtSetSensitive(mymenu.calc.rectify,True);
    XtSetSensitive(mymenu.calc.invert,True);
    XtSetSensitive(mymenu.calc.differentiate,True);
    XtSetSensitive(mymenu.calc.linear,True);
    XtSetSensitive(mymenu.calc.twochtrans,True);
    XtSetSensitive(mymenu.calc.fft,True);
    XtSetSensitive(mymenu.calc.baro,True);
    XtSetSensitive(mymenu.calc.artifact,True);
    XtSetSensitive(mymenu.view.redraw,True);
    XtSetSensitive(mymenu.view.zoom,True);
    XtSetSensitive(mymenu.view.total,True);
    XtSetSensitive(mymenu.view.hide,True);
    XtSetSensitive(mymenu.view.all,True);
    XtSetSensitive(mymenu.view.comments,True);
    XtSetSensitive(mess.rowcol_w,True);
    XtSetSensitive(toolb_w,True);
  }

  XtFree(filename);
  XtFree((char *)pos_list);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XtUnmanageChild(widget);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  return;
}

void sd_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           i, n;
  Arg           args[5];
  static Widget fexist;
  char          *filename;
  ofstream      dat;
  //extern int    errno;
  void write_data(Widget, XtPointer, XtPointer);

  /* get filename */
  XmFileSelectionBoxCallbackStruct *cbs= 
    (XmFileSelectionBoxCallbackStruct *) call_data;
  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }

  /* check whether file exists */
  dat.open(filename, ios::noreplace);
  if (errno==EEXIST) {
    if (!fexist) {
      n=0;
      XtSetArg(args[n], XmNmessageString, XmStringCreateLtoR("File already exists.\n     Overwrite?",XmFONTLIST_DEFAULT_TAG)); n++;
      XtSetArg(args[n], XmNokLabelString, XmStringCreateLocalized(" Yes ")); n++;
      XtSetArg(args[n], XmNcancelLabelString, XmStringCreateLocalized(" No ")); n++;
      XtSetArg(args[n], XmNtitle, "Save Data"); n++;
      fexist=XmCreateQuestionDialog(drawing_a, "fexist", args, n);
      XtAddCallback(fexist, XmNokCallback, write_data, widget);
      XtUnmanageChild(XmMessageBoxGetChild(fexist, XmDIALOG_HELP_BUTTON));
    }
    XtManageChild(fexist);
    XtPopup(XtParent(fexist), XtGrabNone);
  }
  if (dat) {
    dat.close();
    write_data(NULL, widget, NULL);
  }

  XtFree(filename);
  return;
}

void write_data(Widget w, XtPointer client_data, XtPointer call_data) {

  REGIST        s_reg;
  XmString      fname;
  Cursor        uhr, pfeil;
  Widget        fsb_sd, ft_sd, madbox, toplevel;
  Arg           args[5];
  char          *filename, titles[100], *pfname;
  int           i, *pos_list, pos_cnt;
  unsigned long n, n1, n2;
  short         save_chn;

  toplevel=drawing_a;
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);
  fsb_sd=(Widget)client_data;
  uhr  =XCreateFontCursor(XtDisplay(fsb_sd), XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(fsb_sd), XC_arrow);
  XDefineCursor(XtDisplay(fsb_sd),XtWindow(fsb_sd),uhr);
  XFlush(XtDisplay(fsb_sd));

  /* get filename */
  XtVaGetValues(fsb_sd, XmNdirSpec, &fname, NULL);
  XmStringGetLtoR(fname, XmFONTLIST_DEFAULT_TAG, &filename);

  /* get filetype 1: ASCII, 2: TSA, 3: MAD */
  /* returned in pos_list[0]               */
  XtVaGetValues(fsb_sd, XmNuserData, &ft_sd, NULL);
  XmListGetSelectedPos(ft_sd, &pos_list, &pos_cnt);

  /* fill new Regist for saving */
  for (i=0; i<r.n; i++) if (r.view[i].is_visible) s_reg.n++;
  s_reg.ch=(REGIST::CHANNEL *) realloc(s_reg.ch,s_reg.n*sizeof(REGIST::CHANNEL));

  save_chn=-1;
  for (i=0; i<r.n; i++) {
    if (r.view[i].is_visible) {
      save_chn++;
      n1=(unsigned long)(r.t_1*r.ch[i].sr);
      if (n1<0) n1=0;
      if (n1>=r.ch[i].n) n1=r.ch[i].n-1;
      n2=(unsigned long)(r.t_2*r.ch[i].sr);
      if (n2>=r.ch[i].n) n2=r.ch[i].n-1;
      if (n2<0) n2=0;
      if (n2>n1) {
	s_reg.ch[save_chn].data=(r.ch[i].data+n1);
	s_reg.ch[save_chn].n=(n2-n1+1);
	s_reg.ch[save_chn].sr=r.ch[i].sr;
	s_reg.ch[save_chn].min=r.view[i].min;
	s_reg.ch[save_chn].max=r.view[i].max;
	s_reg.ch[save_chn].name=r.ch[i].name;
	s_reg.ch[save_chn].unit=r.ch[i].unit;
      }
    }
  }

  switch(pos_list[0]) {
  case 1:
    s_reg.WriteASCII(filename);
    break;
  case 2:
    s_reg.WriteTSA(filename);
    break;
  case 3:
      i=0;
      XtSetArg(args[i], XmNmessageString, XmStringCreateLtoR("MAD format not implemented yet!",XmFONTLIST_DEFAULT_TAG)); i++;
      XtSetArg(args[i], XmNtitle, "MAD format"); i++;
      madbox=XmCreateMessageDialog(drawing_a, "not_done", args, i);
      XtUnmanageChild(XmMessageBoxGetChild(madbox, XmDIALOG_HELP_BUTTON));
      XtUnmanageChild(XmMessageBoxGetChild(madbox, XmDIALOG_CANCEL_BUTTON));
      XtManageChild(madbox);
    break;
  }

  s_reg.n=0;
  pfname=strrchr(filename,'/');
  if (pfname) pfname=pfname+1;
  else pfname=filename;
  strcpy(titles,"xmana v"VERSION": "); strcat(titles,pfname);
  XtVaSetValues(toplevel, XmNtitle, titles, NULL);
  XDefineCursor(XtDisplay(fsb_sd),XtWindow(fsb_sd),pfeil);
  XFlush(XtDisplay(fsb_sd));
  XtUnmanageChild(fsb_sd);
  XmStringFree(fname);
  XtFree((char *)pos_list);
  XtFree(filename);
  XFreeCursor(XtDisplay(fsb_sd), pfeil);
  XFreeCursor(XtDisplay(fsb_sd), uhr);
}

void ok_sr(Widget widget, XtPointer client_data, XtPointer call_data) {
  int      i, rc;  
  Widget   tfield=(Widget)client_data;
  Widget   toplevel, fsb_ld;
  Cursor   uhr, pfeil;
  XmString fname;
  char     *filename, *pfname, *text, titles[100];
  float    sr;
  int      nch_old;

  extern void da_cb(Widget widget, XtPointer client_data, XtPointer call_data);

  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
  XtVaGetValues(tfield,
		XmNuserData, &fsb_ld,
		XmNvalue, &text,
		NULL);
  XtVaGetValues(fsb_ld, XmNdirSpec, &fname, NULL);
  XmStringGetLtoR(fname, XmFONTLIST_DEFAULT_TAG, &filename);
  if (atof(text)>0) {
    sr=atof(text);
    XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
    XFlush(XtDisplay(widget));
    nch_old=r.n;
    rc=r.ReadASCII(filename,sr);
    XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
    XFlush(XtDisplay(widget));
    XtUnmanageChild(widget);
  }
  else rc=-1;
  XtFree(text);
  if (rc>=0) {
    r.alloc_view(r.n);
    r.t_1=0; r.t_2=0; r.nvis+=(r.n-nch_old);
    for (i=nch_old; i<r.n; i++) {
      r.view[i].is_active=0;
      r.view[i].is_visible=1;
      r.view[i].is_frequency=0;
      r.view[i].min=r.ch[i].min;
      r.view[i].max=r.ch[i].max;
      strcpy(r.view[i].from_file,filename);
      if (r.t_2<r.ch[i].n/r.ch[i].sr) r.t_2=r.ch[i].n/r.ch[i].sr;
    }
    toplevel=drawing_a;
    while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);
    pfname=strrchr(filename,'/');
    if (pfname) pfname=pfname+1;
    else pfname=filename;
    strcpy(titles,"xmana v"VERSION": "); strcat(titles,pfname);
    XtVaSetValues(toplevel, XmNtitle, titles, NULL);
    da_cb(NULL, NULL, NULL);

    XtSetSensitive(mymenu.file.n_data,True);
    XtSetSensitive(mymenu.file.s_data,True);
    XtSetSensitive(mymenu.file.p_data,True);
    XtSetSensitive(mymenu.edit.mean,True);
    XtSetSensitive(mymenu.edit.area,True);
    XtSetSensitive(mymenu.edit.min,True);
    XtSetSensitive(mymenu.edit.max,True);
    XtSetSensitive(mymenu.edit.dif,True);
    XtSetSensitive(mymenu.edit.deltax,True);
    XtSetSensitive(mymenu.edit.copy,True);
    XtSetSensitive(mymenu.edit.del,True);
    XtSetSensitive(mymenu.edit.reduce,True);
    XtSetSensitive(mymenu.calc.hr1,True);
    XtSetSensitive(mymenu.calc.hr2,True);
    XtSetSensitive(mymenu.calc.filter,True);
    XtSetSensitive(mymenu.calc.interpol,True);
    XtSetSensitive(mymenu.calc.movavg,True);
    XtSetSensitive(mymenu.calc.seqavg,True);
    XtSetSensitive(mymenu.calc.rectify,True);
    XtSetSensitive(mymenu.calc.invert,True);
    XtSetSensitive(mymenu.calc.differentiate,True);
    XtSetSensitive(mymenu.calc.linear,True);
    XtSetSensitive(mymenu.calc.twochtrans,True);
    XtSetSensitive(mymenu.calc.fft,True);
    XtSetSensitive(mymenu.calc.baro,True);
    XtSetSensitive(mymenu.calc.artifact,True);
    XtSetSensitive(mymenu.view.redraw,True);
    XtSetSensitive(mymenu.view.zoom,True);
    XtSetSensitive(mymenu.view.total,True);
    XtSetSensitive(mymenu.view.hide,True);
    XtSetSensitive(mymenu.view.all,True);
    XtSetSensitive(mymenu.view.comments,True);
    XtSetSensitive(mess.rowcol_w,True);
    XtSetSensitive(toolb_w,True);
  }
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  XmStringFree(fname);
  XtFree(filename);
}










